# TBasicMovie Class Reference
[Base Classes for plugins]

Inheritance diagram for TBasicMovie:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | QueryInterface (const MCIID &riid, void **ppvObj)
virtual uint32 MCCOMAPI | AddRef ()
virtual MCCOMErr MCCOMAPI | CreateMovieController (IMFPart **movieController)
virtual MCCOMErr MCCOMAPI | SelfStartPlaying (uint32 frameIndex)
virtual MCCOMErr MCCOMAPI | SelfStopPlaying (uint32 frameIndex)
virtual MCCOMErr MCCOMAPI | Initialize (const TMCString &fullPathName, const TSequencedMovieInfos *infos=NULL)
virtual MCCOMErr MCCOMAPI | BeginRead ()
virtual MCCOMErr MCCOMAPI | GetFrameRate (real32 &frameRate)
virtual MCCOMErr MCCOMAPI | GetFrameCount (uint32 &frameCount)
virtual MCCOMErr MCCOMAPI | GetFrame (IShRasterLayer **rasterLayer, uint32 frameIndex)
virtual MCCOMErr MCCOMAPI | GetFrame (IShLayerList **layerList, uint32 frameIndex, boolean forceLoad)
virtual MCCOMErr MCCOMAPI | EndRead ()
virtual boolean MCCOMAPI | HasOptionsDialog ()
virtual MCCOMErr MCCOMAPI | ShowOptionsDialog (uint32 depth, real32 &frameRate)
virtual MCCOMErr MCCOMAPI | BeginWrite (const TMCString &fullPathName, uint32 sizeH, uint32 sizeV, uint32 depth, real32 frameRate, boolean append)
virtual MCCOMErr MCCOMAPI | PutFrame (IShRasterLayer *rasterLayer, const TGBuffer32List *gBuffers, uint32 frameIndex)
virtual MCCOMErr MCCOMAPI | PutFrame (IShLayerList *layerList, const TGBuffer32List *gBuffers, uint32 frameIndex)
virtual MCCOMErr MCCOMAPI | Flush ()
virtual MCCOMErr MCCOMAPI | GetMovieFullPathName (TMCString &fullPathName)
virtual MCCOMErr MCCOMAPI | EndWrite ()
virtual MCCOMErr MCCOMAPI | MakeCopy (const TMCString &fullPathName, TMCString &outFirstFileName)
virtual void MCCOMAPI | GetCapabilities (ImageExportCapabilities &capabitilities)
virtual MCCOMErr MCCOMAPI | DeleteMovie ()
virtual void MCCOMAPI | GetCompressionOptions (IExMovieCompressionOptions **movieOptions)
virtual void MCCOMAPI | SetCompressionOptions (IExMovieCompressionOptions *movieOptions)

## Detailed Description

Basic Movie class. Derive from this for a basic implementation of IExMovie

See also:
  IExMovie

## Member Function Documentation

virtual uint32 MCCOMAPI TBasicMovie::AddRef | ( |  | ) | `[virtual]`

Increments the reference count of the object

Reimplemented from TBasicDataExchanger.

virtual MCCOMErr MCCOMAPI TBasicMovie::BeginRead | ( |  | ) | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::BeginWrite | ( | const TMCString & | fullPathName,
|  | uint32 | sizeH,
|  | uint32 | sizeV,
|  | uint32 | depth,
|  | real32 | frameRate,
|  | boolean | append |
| ) |  |  | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::CreateMovieController | ( | IMFPart ** | movieController | ) | `[virtual]`

Creates a movie controller. Return MC_E_NOTIMPL and a standard movie controller will be provided.

Parameters:

  | movieController | A pointer to a movie controller part.

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::DeleteMovie | ( |  | ) | `[virtual]`

Deletes the movie

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::EndRead | ( |  | ) | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::EndWrite | ( |  | ) | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::Flush | ( |  | ) | `[virtual]`

Calling flush insures that the movie file is valid up to the last PutFrame.

Implements IExMovie.

virtual void MCCOMAPI TBasicMovie::GetCapabilities | ( | ImageExportCapabilities & | capabitilities | ) | `[virtual]`

Returns which buffers can be saved with this file format

Parameters:

  | capabitilities | Flags that are returned.

Implements IExMovie.

virtual void MCCOMAPI TBasicMovie::GetCompressionOptions | ( | IExMovieCompressionOptions ** | movieOptions | ) | `[virtual]`

Returns a pointer to the compression options used for this movie

Parameters:

  | movieOptions |

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::GetFrame | ( | IShLayerList ** | layerList,
|  | uint32 | frameIndex,
|  | boolean | forceLoad |
| ) |  |  | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::GetFrame | ( | IShRasterLayer ** | rasterLayer,
|  | uint32 | frameIndex |
| ) |  |  | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::GetFrameCount | ( | uint32 & | frameCount | ) | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::GetFrameRate | ( | real32 & | frameRate | ) | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::GetMovieFullPathName | ( | TMCString & | fullPathName | ) | `[virtual]`

Sometimes the file name can change between open and save. More specifically, when using numbered files. you save "Movie.jpg" but you reopen "Movie001.jpg" because this is the actual file. Return MC_E_NOTIMPL and the shell will provide a default implementation

Parameters:

  | fullPathName |

Implements IExMovie.

virtual boolean MCCOMAPI TBasicMovie::HasOptionsDialog | ( |  | ) | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::Initialize | ( | const TMCString & | fullPathName,
|  | const TSequencedMovieInfos * | infos = `NULL` |
| ) |  |  | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::MakeCopy | ( | const TMCString & | fullPathName,
|  | TMCString & | outFirstFileName |
| ) |  |  | `[virtual]`

Makes an exact copy of the movie to the location given by fullPathName. Returns the name of the first written file (equals fullPathName if non sequenced) Return MC_E_NOTIMPL and the shell will provide a default implementation.

Parameters:

  | fullPathName |
  | outFirstFileName |

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::PutFrame | ( | IShLayerList * | layerList,
|  | const TGBuffer32List * | gBuffers,
|  | uint32 | frameIndex |
| ) |  |  | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::PutFrame | ( | IShRasterLayer * | rasterLayer,
|  | const TGBuffer32List * | gBuffers,
|  | uint32 | frameIndex |
| ) |  |  | `[virtual]`

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::QueryInterface | ( | const MCIID & | riid,
|  | void ** | ppvObj |
| ) |  |  | `[virtual]`

Check if the object supports a given interface and returns a pointer to that interface if it does. Note that QueryInterface will increment the reference count of the object by one if the interface is found.

Parameters:

  | riid | GUID of the interface
  | ppvObj | A pointer to the pointer being returned.

Reimplemented from TBasicDataExchanger.

virtual MCCOMErr MCCOMAPI TBasicMovie::SelfStartPlaying | ( | uint32 | frameIndex | ) | `[virtual]`

Called only when the standard movie controller is used

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::SelfStopPlaying | ( | uint32 | frameIndex | ) | `[virtual]`

Called only when the standard movie controller is used

Implements IExMovie.

virtual void MCCOMAPI TBasicMovie::SetCompressionOptions | ( | IExMovieCompressionOptions * | movieOptions | ) | `[virtual]`

Sets the compression options used for this movie

Implements IExMovie.

virtual MCCOMErr MCCOMAPI TBasicMovie::ShowOptionsDialog | ( | uint32 | depth,
|  | real32 & | frameRate |
| ) |  |  | `[virtual]`

Implements IExMovie.

The documentation for this class was generated from the following file:

- BasicMovie.h